function [proc_sig ,dig_sig ,freq ] = work_proc

%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================

data_hndl = findobj(gcbf , 'Tag' , 'push_quit');
sig_info = get (data_hndl ,'Userdata');


freq = sig_info.fs;

time = 0: 1/freq : 1;

switch (sig_info.name)
   
case('Sine'),
  proc_sig = sin ( 2 *pi * sig_info.freq1 *  time);
  
case('Triangular'),
  proc_sig = sawtooth ( 2 *pi * sig_info.freq1 *  time , 0.5);
  
case('Square'),
   proc_sig = square ( 2 *pi * sig_info.freq1 *  time);
   
case('2-Sine')
   proc_sig = sin (2*pi*sig_info.freq1*time) + sin (2*pi*sig_info.freq2*time);
   proc_sig = proc_sig / 2;
   
end
dig_sig = proc_sig;

if ( ~ strcmp( sig_info.bps , 'Inf') )
   dig_sig = s1_quantize ( proc_sig , str2num ( sig_info.bps ) );
end


     

