function fig = s3_gui()
%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================
% This is the machine-generated representation of a Handle Graphics object
% and its children.  Note that handle values may change when these objects
% are re-created. This may cause problems with any callbacks written to
% depend on the value of the handle at the time the object was saved.
%
% To reopen this object, just type the name of the M-file at the MATLAB
% prompt. The M-file and its associated MAT-file must be on your path.

load s3_gui

h0 = figure('Color',[0.8 0.8 0.8], ...
	'Colormap',mat0, ...
	'HandleVisibility','callback', ...
	'Name','Sinusoid sampling', ...
	'NumberTitle','off', ...
	'PointerShapeCData',mat1, ...
	'Position',[15 46 444 200], ...
	'Tag','Fig1');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
	'ListboxTop',0, ...
	'Position',[51 111.75 189 20.25], ...
	'String','Effects of sampling sinusoids', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[14.25 11.25 105 83.25], ...
	'Style','frame', ...
	'Tag','Frame1');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
	'ListboxTop',0, ...
	'Position',[150 11.25 149.25 81], ...
	'Style','frame', ...
	'Tag','Frame2');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'Callback','eval(''play_sig3c_org'');', ...
	'ListboxTop',0, ...
	'Position',[159 59.25 58.5 21.75], ...
	'String','Play Orginal', ...
	'Tag','push_org');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'Callback','eval(''play_samp'');', ...
	'ListboxTop',0, ...
	'Position',[159 20.25 58.5 23.25], ...
	'String','Play sampled', ...
	'Tag','push_samp');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'Callback','clear;close all;', ...
	'ListboxTop',0, ...
	'Position',[234 21 61.5 22.5], ...
	'String','Quit demo', ...
	'Tag','push_exit');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
	'Callback','eval(''set_f'');', ...
	'ListboxTop',0, ...
	'Max',20000, ...
	'Min',20, ...
	'Position',[18.75 59.25 66.75 13.5], ...
	'SliderStep',[0.0005 0.005], ...
	'Style','slider', ...
	'Tag','slid_f', ...
	'UserData',10000, ...
	'Value',10000.00999999999);
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[87.75 59.25 28.5 13.5], ...
	'String','10000', ...
	'Style','text', ...
	'Tag','static_f');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
	'Callback','eval(''set_s3_fs'');', ...
	'ListboxTop',0, ...
	'Max',44000, ...
	'Min',5000, ...
	'Position',[18.75 22.5 66.75 13.5], ...
	'SliderStep',[0.025 0.25], ...
	'Style','slider', ...
	'Tag','slid_fs', ...
	'UserData',23000, ...
	'Value',23252);
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[87 22.5 27 13.5], ...
	'String','23000', ...
	'Style','text', ...
	'Tag','static_fs');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[20.25 74.25 64.5 13.5], ...
	'String','Freq of sine', ...
	'Style','text', ...
	'Tag','StaticText4');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'Callback','eval(''set_s3_fs'');', ...
	'ListboxTop',0, ...
	'Position',[21 36 63 13.5], ...
	'String','Sampling freq', ...
	'Style','text', ...
	'Tag','StaticText5');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'Callback','eval(''play_aliased'');', ...
	'Enable','off', ...
	'ListboxTop',0, ...
	'Position',[231.75 57.75 61.5 23.25], ...
	'String','Play  Hz', ...
	'Tag','push_fnew');
if nargout > 0, fig = h0; end
