function show_psd
%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================
%function performs wiener filtering
%==================================

%get the noisy_signal
%--------------------

data_hndl = findobj (gcbf , 'Tag' ,'push_noisy');
sig_info = get( data_hndl , 'Userdata');
data = sig_info.data;
fs = sig_info.freq;
D_len = length(data);

%-------------------------------------------


%get the true signal (for spectrum extraction)
hndl = findobj(gcbf , 'Tag' , 'push_select');
sig_info = get(hndl,'Userdata');
sig = sig_info.data;

%check the psd type - true or assumed spectrum
psd_hndl = findobj(gcbf,'Tag','list_psd');
val = get(psd_hndl,'Value');
names = get(psd_hndl,'String');
psd_type = names{val};

%computing the psd - as FT of xcorr
p = my_psd(sig,D_len);
N = 100;
b = ones(1,N)/N;

switch psd_type
   
case 'True'
case 'Assumed'
   %average with 10 guys
    p = filter (b,1,p);
   
end

%at this point the signal psd is found
%----------------------------------------

%find the psd for the error signal
%get the noise_eg in the userdata

noise_eg = get(psd_hndl ,'Userdata');
noise_p =  my_psd(noise_eg,D_len);
noise_p = filter(b,1,noise_p);

%----------------------------------------------------------
% at this point the spectra are ready..
H = p./(p + noise_p);
H_len = length(H);


%perform linear convolution
FIN = H .* fft(data,length(H));
fin = real(ifft(FIN));
%save this sig for play back
hndl = findobj(gcbf,'Tag','push_filt');
u=sig_info;
u.data = fin(1:D_len);
set(hndl,'Userdata',u);
%soundsc(fin(1:D_len),fs);

%-------------------------------------------------------------
%finish up with the plots
figure(2);
org_psd = my_psd(data , D_len);

mid = floor(length(org_psd)/2);
my_w = linspace(0,1,mid);

subplot(2,2,1),plot(my_w,org_psd(1:mid));
title('Original psd');

subplot(2,2,2),plot(my_w,p(1:mid));
title('Assumed psd');

subplot(2,2,3),plot(my_w,noise_p(1:mid));
title('psd of Noise');


H = filter(b,1,H);
subplot(2,2,4),plot(my_w,H(1:mid));
title('DFT of filter');



%---------------------------------
%figure(3);
%plot(data);
%hold on;
%plot (sig,'r--');
%plot (fin(1:D_len),'g--');





