function[num,den,success] =   make_iirqnt_filter()

%function make_iirqnt_filter()

success = 1;
hndl = gcbf;

%get the handles for the filters

name_hndl =  findobj ( hndl , 'Tag' , 'fil_name');
type_hndl =  findobj ( hndl , 'Tag' , 'fil_type');
pbr_hndl = findobj ( hndl , 'Tag' , 'Edit_psr');
sbr_hndl = findobj ( hndl , 'Tag' , 'Edit_sbr');

pb1_hndl = findobj ( hndl , 'Tag' , 'Slider_pb1');
sb1_hndl = findobj ( hndl , 'Tag' , 'Slider_sb1');

order_hndl =  findobj ( hndl , 'Tag' , 'Slider_order');
order_static = findobj ( hndl , 'Tag' , 'Static_order');



fil_name = get (name_hndl, 'UserData');
fil_type = get (type_hndl, 'UserData');
Rp = get (pbr_hndl, 'UserData'); %passband ripple
Rs = get (sbr_hndl, 'UserData'); %stopband ripple

fil_f1 = get (pb1_hndl, 'UserData');
fil_f2 = get (sb1_hndl, 'UserData');

fil_ord =  floor(get (order_hndl , 'Value'));
set(order_static,'String',num2str(fil_ord));

%checking of order is correct
if ( isempty (fil_ord) | fil_ord <=0 ) 
   errordlg ('Please Enter valid filter order');
   success = 0;
   return;
end

%checking of frequency points are correctly given
if ( not (isempty(fil_f2)))
   if (fil_f1 >= fil_f2)
      errordlg('Freq1 shud be < Freq2');
      success = 0;
      return;
   end
end

fil_freq = [fil_f1 fil_f2];


switch (fil_name)
      
   case('Butterworth'),
      [num,den] = butter (fil_ord, fil_freq ,fil_type);
      
   case('Cheby-1'),
      [num,den] = cheby1 (fil_ord , Rp , fil_freq , fil_type);
      
	case('Cheby-2'),
      [num,den] = cheby2 (fil_ord , Rs , fil_freq , fil_type);
      
	case('Elliptical'),
      [num,den] = ellip (fil_ord , Rp,Rs, fil_freq ,fil_type);         
      
end

   
qnt_hndl = findobj (gcbf , 'Tag', 'Pop_qnt');
qnt_val = get (qnt_hndl,'Userdata');

if (isempty (qnt_val))
   return;
end

num = iirqnt_trunc ( num, qnt_val);
den = iirqnt_trunc ( den , qnt_val);
den(1) = 1;
