function set_signal
%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================
main_hndl = gcbf;
sig_hndl = findobj(main_hndl,'Tag','PopupMenu1');
dc_hndl =  findobj(main_hndl,'Tag','PopupMenu2');
freq_hndl = findobj(main_hndl,'Tag','PopupMenu4');

sig_string = get(sig_hndl,'String');
sig_val = get(sig_hndl , 'Value');
sig_name = sig_string{sig_val};
   
dc_string = get(dc_hndl,'String');
dc_val = get(dc_hndl , 'Value');
dc = str2num ( dc_string{dc_val});

freq_string = get(freq_hndl,'String');
freq_val = get(freq_hndl , 'Value');
freq = str2num ( freq_string{freq_val});



N =128;
n = 2* N;
To =1/freq;;

t= linspace (0,To,n+1);
t(end) = [];
t_size = length(t);

set (freq_hndl,'Enable','on');

switch (sig_name),
   
case ('Sine')
   f = sin(2*pi*freq*t) + dc  ;
case ('Cosine')
   f = cos(2*pi*freq*t) + dc  ;
case ('Triangular')
   f = sawtooth(2*pi*freq*t) + dc  ;
case ('Sawtooth')
   f = sawtooth(2*pi*freq*t,0.5) + dc  ;
case ('Square')
   f = square(2*pi*freq*t) + dc  ;
case('Random')
   set (freq_hndl,'Enable','off');
   f = 2* ( rand (1 , length(t) ) - 0.5 ) + dc;
   
end


set (sig_hndl , 'UserData' , f);
set (freq_hndl , 'UserData' , freq);

my_display;
