function show_3d
%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================

xmin = -2; xstep = 0.1; xmax = 2;
ymin = -2; ystep = 0.1; ymax = 2;
x = xmin : xstep : xmax;
y = ymin : ystep : ymax;
[X,Y] = meshgrid(x,y);

Z =(abs( eval_func (X+ j*Y)) )+eps;
%Z = Z / max (max(Z));


figure ( 2 );
clf;
surf(X, Y, log10(Z))           % Draw and label the surface
shading interp
colormap(cool)
title('Z- transform in 3-D');
xlabel('Re');
ylabel('Im');
zlabel('10logabs(H)');


%trying to get the mag along the unit cirlce
hold on;
w = linspace ( -pi , pi ,1000);

X1 = cos ( w);
Y1 = sin (w);
z1 = exp (j * w );

Z1 = abs(eval_func(z1))+eps;
%Z1 = Z1 / max(Z1);
plot3 (X1, Y1, log10(Z1),'g' );
zoom on;
rotate3d on;
box
colormap('hot');


%playing around with the figure to make a nice display
h = gcf;
set(h,'Color',[0 0 0]);	%set background to black

a = gca;
set(a,'Color',[0 0 0],'GridLineStyle',':');
set(a,'XColor',[1 1 1],'YColor',[1 1 1],'ZColor',[1 1 1]);


