function shear_animator (action)

%if (nargin < 2) start_X= [];

switch(action)
    case 'start'
        fig_handles = guihandles;
        set(gcbf,'WindowButtonMotionFcn','shear_animator move');
        set(gcbf,'WindowButtonUpFcn','shear_animator stop');
        currPt = get(gca,'CurrentPoint');
        start_Y  = currPt(1,2);
%        title(num2str(start_Y));

        my_data = guidata(fig_handles.axes_phase);
        my_data.start_Y=start_Y;
        guidata(fig_handles.axes_phase,my_data);
%        guidata(gcbf,start_Y);
%        set(gcbf,'WindowButtonDownFcn','animator down');
        
    case 'move'
        
          fig_handles = guihandles;
          
         %linear = 1;
         phase_types = get(fig_handles.listbox_phase,'String');
         phase_select = get(fig_handles.listbox_phase,'Value');
         phase_option = phase_types(phase_select);
         
         if strcmp(phase_option,'Linear')
             linear = 1;
         else
             linear = 0;
         end

          
          axes(fig_handles.axes_phase);
          my_data = guidata(fig_handles.axes_phase); %Structure in init_shear_gui
          start_Y = my_data.start_Y;
          currPt = get(gca,'CurrentPoint');
          end_Y = currPt(1,2);
          end_X = currPt(1,1);
          
          if ( end_X < 0) end_Y = sign(end_X) * end_Y; end
          
          shift = end_Y - start_Y;
%          title(['Start ' num2str(start_Y) ' End ' num2str(end_Y) ' Index-' num2str(change_index)]);
         
          x_axis= my_data.lin_x;
          lin_line = my_data.lin_y;
          old_line = my_data.cur_y;
          
%          change_index = round(currPt(1,1));
           change_index = (currPt(1,1));
          actual_index = find(x_axis > change_index);
          actual_index = actual_index(1);

        if (linear)

           %Linear Change
          change_index = floor(currPt(1,1));
          slope = currPt(1,2)/currPt(1,1);
%          new_line = slope*x_axis;
          new_line = x_axis;
          new_line = new_line/new_line(actual_index) * shift;
          new_line = new_line + old_line;
%           new_line = slope*_line;
%          title(['Slope- ' num2str(slope)]);
          set(fig_handles.text_slope,'Visible','On');
          set(fig_handles.text_slope,'String',['Shift is ' num2str(floor(slope))]);
         
        else    
          %Non Linear Change
          %=================  
           set(fig_handles.text_slope,'Visible','Off');
          %Make Gaussian to sit over old line  
          SIGMA = 0.01*(max(x_axis)-min(x_axis));
          temp_gauss = (1/2*pi*sqrt(SIGMA))*exp( -(x_axis - change_index).^2/(2*SIGMA));
          temp_gauss = temp_gauss/temp_gauss(actual_index)*shift; %Amplitude of gaussian = shift
          new_line = old_line + temp_gauss;
%          new_line = new_line/abs(new_line(change_index))*end_Y;
          
    end
          hold on; cla;
          
          plot(x_axis,lin_line,'w');
          h = plot(x_axis, new_line ,'y','LineWidth',2);
          set(h,'ButtonDownFcn', 'shear_animator start');
           axis([min(x_axis),max(x_axis), -1000 1000 ]);
           xlabel('Digital Frequency'); ylabel('Shift (Samples)');
          
          %Save the current line settings
          my_data.cur_y = new_line;
          my_data.start_Y = end_Y;
          guidata(fig_handles.axes_phase,my_data);
          
          update_time_sig;

     case 'stop'
        set(gcbf,'WindowButtonMotionFcn','');
        set(gcbf,'WindowButtonUpFcn','');

        
end



