function reset_sineadd

fig_handles = guihandles; 

N = 64; K1 = 2; K2= 3*K1;  GAIN = 0.5;

common_data.N = N;
common_data.k1 = K1;
common_data.k2 = K2;
common_data.gain = GAIN;
set(fig_handles.push_reset,'UserData',common_data);

sig1_data.k = K1;
sig1_data.shift = 0;
sig1_data.init_time = 0;
set(fig_handles.axes_sig1,'UserData',sig1_data);

sig2_data.k = K2;
sig2_data.shift = 0;
sig2_data.init_time = 0;
set(fig_handles.axes_sig2,'UserData',sig2_data);



%Make the 3 signals
[sig1,sig1_shift, time1] = make_sine(sig1_data);
[sig2,sig2_shift, time2] = make_sine(sig2_data);
sig3 = sig1 +  GAIN * sig2;

%Compute the best time axes
max_y = max(sig1) + max(sig2);
min_x = 0; max_x = N;

%Plot the signals in the time domain
axes(fig_handles.axes_sig1);
cla; hold on; 
plot(time1,sig1);
h = plot(time1,sig1,'g');
set(h,'ButtonDownFcn', 'sine_add_animator start');
axis([min_x max_x -max_y max_y]);


axes(fig_handles.axes_sig2);
cla; hold on;
plot(time1,sig2);axis tight;
h = plot(time2,sig2,'g');
set(h,'ButtonDownFcn', 'sine_add_animator start');
axis([min_x max_x -max_y max_y]);

axes(fig_handles.axes_sig3);
cla; hold on;
plot(time1,sig3);axis tight;
h = plot(time1,sig3,'g');
set(h,'ButtonDownFcn', 'sine_add_animator start');
axis([min_x max_x -max_y max_y]);

sig3_data.k = 0;
sig3_data.shift = 0;
sig3_data.init_time = 0;
set(fig_handles.axes_sig3,'UserData',sig3_data);


update_all_time_plots;