function varargout = sivaDSP(varargin)
% SIVADSP Application M-file for sivaDSP.fig
%    FIG = SIVADSP launch sivaDSP GUI.
%    SIVADSP('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 30-Aug-2010 17:09:21

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

    [unique_classes, demo_struct] = read_demo_info;
    set(handles.list_main,'String',unique_classes);
    current_main_val = get(handles.list_main,'Value'); current_main = unique_classes(current_main_val);
    gui_names = guis_under_unique(demo_struct,current_main);
    set(handles.list_sec,'String',gui_names);
%    plot([1:5],'Tag','axes_title');
    
    [siva_banner,map,alpha] = imread('siva_title.jpg');
    imshow(siva_banner,map); axis image;
    set(handles.fig_toc,'HandleVisibility','off'); %Hide the figure again
    
   
	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

   
	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end
    


end



%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.



% --------------------------------------------------------------------
function varargout = listbox1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
set(handles.list_sec,'Value',1); %Reset the selected value to the first option
[unique_classes, demo_struct] = read_demo_info;
%set(handles.list_main,'String',unique_classes);
current_main_val = get(handles.list_main,'Value'); current_main = unique_classes(current_main_val);
gui_names = guis_under_unique(demo_struct,current_main);
set(handles.list_sec,'String',gui_names);


% --------------------------------------------------------------------
function varargout = listbox2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox2.
%disp('listbox2 Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.pushbutton1.
%disp('pushbutton1 Callback not implemented yet.')
close(handles.fig_toc);

% --------------------------------------------------------------------
function varargout = pushbutton2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.pushbutton2.
%disp('pushbutton2 Callback not implemented yet.')
[unique_classes, demo_struct] = read_demo_info;
current_main_val = get(handles.list_main,'Value'); current_main = unique_classes(current_main_val);
gui_names = guis_under_unique(demo_struct,current_main);
current_sub_val = get(handles.list_sec,'Value'); current_sec = gui_names(current_sub_val);


%Find which demo to run
for i = 1:length(demo_struct)
    temp_struct = demo_struct{i};
    if strcmp(temp_struct.gui_name,current_sec)
      run_struct = temp_struct; break;
    end
end

%run_struct has the structure that needs to be run
%current_path = pwd; 
%slash_ind = findstr(current_path,'\');
%all_demos_path = current_path(1:slash_ind(end)-1);
%demo_path = run_struct.gui_location; 
%final_path = [all_demos_path '\' demo_path]; slash_ind = findstr(final_path,'\');
%final_path = final_path(1:slash_ind(end));
eval(run_struct.gui_location);


function gui_names = guis_under_unique(demo_struct,unique_name)

my_count = 0;

for i = 1:length(demo_struct)

    temp_struct = demo_struct{i};
    if strcmp(temp_struct.gui_class,unique_name)
        my_count = my_count+1;    
        gui_names{my_count}=temp_struct.gui_name;
    end
end
